# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from nao_interaction_msgs/AudioSourceLocalization.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class AudioSourceLocalization(genpy.Message):
  _md5sum = "5c65a283c3f4c0f07561982b3d8c4f13"
  _type = "nao_interaction_msgs/AudioSourceLocalization"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Message emitted by Nao ALAudioSourceLocalizationProxy wrapper.
# Contains information about sound localization

Header header

std_msgs/Float32 azimuth
std_msgs/Float32 elevation
std_msgs/Float32 confidence
std_msgs/Float32 energy

geometry_msgs/Pose head_pose


================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: std_msgs/Float32
float32 data
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['header','azimuth','elevation','confidence','energy','head_pose']
  _slot_types = ['std_msgs/Header','std_msgs/Float32','std_msgs/Float32','std_msgs/Float32','std_msgs/Float32','geometry_msgs/Pose']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,azimuth,elevation,confidence,energy,head_pose

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AudioSourceLocalization, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.azimuth is None:
        self.azimuth = std_msgs.msg.Float32()
      if self.elevation is None:
        self.elevation = std_msgs.msg.Float32()
      if self.confidence is None:
        self.confidence = std_msgs.msg.Float32()
      if self.energy is None:
        self.energy = std_msgs.msg.Float32()
      if self.head_pose is None:
        self.head_pose = geometry_msgs.msg.Pose()
    else:
      self.header = std_msgs.msg.Header()
      self.azimuth = std_msgs.msg.Float32()
      self.elevation = std_msgs.msg.Float32()
      self.confidence = std_msgs.msg.Float32()
      self.energy = std_msgs.msg.Float32()
      self.head_pose = geometry_msgs.msg.Pose()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_4f7d().pack(_x.azimuth.data, _x.elevation.data, _x.confidence.data, _x.energy.data, _x.head_pose.position.x, _x.head_pose.position.y, _x.head_pose.position.z, _x.head_pose.orientation.x, _x.head_pose.orientation.y, _x.head_pose.orientation.z, _x.head_pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.azimuth is None:
        self.azimuth = std_msgs.msg.Float32()
      if self.elevation is None:
        self.elevation = std_msgs.msg.Float32()
      if self.confidence is None:
        self.confidence = std_msgs.msg.Float32()
      if self.energy is None:
        self.energy = std_msgs.msg.Float32()
      if self.head_pose is None:
        self.head_pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.azimuth.data, _x.elevation.data, _x.confidence.data, _x.energy.data, _x.head_pose.position.x, _x.head_pose.position.y, _x.head_pose.position.z, _x.head_pose.orientation.x, _x.head_pose.orientation.y, _x.head_pose.orientation.z, _x.head_pose.orientation.w,) = _get_struct_4f7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_4f7d().pack(_x.azimuth.data, _x.elevation.data, _x.confidence.data, _x.energy.data, _x.head_pose.position.x, _x.head_pose.position.y, _x.head_pose.position.z, _x.head_pose.orientation.x, _x.head_pose.orientation.y, _x.head_pose.orientation.z, _x.head_pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.azimuth is None:
        self.azimuth = std_msgs.msg.Float32()
      if self.elevation is None:
        self.elevation = std_msgs.msg.Float32()
      if self.confidence is None:
        self.confidence = std_msgs.msg.Float32()
      if self.energy is None:
        self.energy = std_msgs.msg.Float32()
      if self.head_pose is None:
        self.head_pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.azimuth.data, _x.elevation.data, _x.confidence.data, _x.energy.data, _x.head_pose.position.x, _x.head_pose.position.y, _x.head_pose.position.z, _x.head_pose.orientation.x, _x.head_pose.orientation.y, _x.head_pose.orientation.z, _x.head_pose.orientation.w,) = _get_struct_4f7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_4f7d = None
def _get_struct_4f7d():
    global _struct_4f7d
    if _struct_4f7d is None:
        _struct_4f7d = struct.Struct("<4f7d")
    return _struct_4f7d
